 program EWndTest;
 {$N+}
{$R helix.RES}
{ $D (C) 1997-1998 by Izydor Apostol}

 {in the first test optimal projrction can be made}
 {in the second test const number of points are preserved and rest is randomized
  and now projection is performed}
uses WinTypes, WinProcs, Strings, OWindows, OStdWnds, Odialogs,WinDos, Objects,BWCC,  OStdDlgs;
         
const
  cm_StartFirstTest = 399;
  cm_StartSecondTest = 400;
  cm_Settings = 402;
  NubPoints = 50;

type
 TSettBuffer = record
         MyTotIt: array [0..5] of char;
         MyMF: array [0..5] of char;
         MyOutP: bool;
         MyMissP: array [0..5] of char;
         end;



type
  TTestApplication = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

  PTestWindow = ^TTestWindow;
  TTestWindow = object(TWindow)
  calculated : boolean;
   number: array [0..999] of char;

    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure MakeHelix;
    procedure CreateMisPoint(apoint:integer);
    procedure OldMatrixCalcul;
    procedure MyOldMatrixCalcul(Varpoint:integer);
     function NewDist(v,w: integer): extended;
    procedure FinalErrorCalcul;
    procedure StepestDescent(NubConstPoints,MaxPoints: integer);
    procedure Paint (PaintDC: HDC; var PaintInfo: TPaintStruct);
     virtual;
    procedure StartTest(var Msg: TMessage);
     virtual cm_First + cm_StartFirstTest;
     procedure ProjectMisPoint(var Msg: TMessage);
     virtual cm_First + cm_StartSecondTest;
    procedure BringCenter(ATPoint:integer);
     procedure Display;
    Procedure CMSettings (Var Msg: TMessage);
      virtual cm_first + cm_Settings;
  end;

  var
   waitcursor:Hcursor;
   aaseq1, aaseq2: array [0..999] of char;
   a,g:integer;
   OldDist: array [0..NubPoints] of array [0..NubPoints] of extended;
   TotalOldDist, Error: extended;
   X,Y, myX, myY: array [0..NubPoints+1] of extended;
   Xm,Ym,Em:extended;
   Sx,Sy:integer;
   XHel, YHel, ZHel: array[0..NubPoints+1] of extended;
   Gx,Gy,Scale,U, B: integer;
   count, AddP : integer;
   SecondTest:bool;
   Mis: integer;
    MisPoint, TotIt: integer;
    OldX, OldY: extended;
    MF: real;
 const
  NubConstPoints = 49;


    SettRecord: TSettBuffer = (
         MyTotIt: '50';
         MyMf: '1.0';
         MyOutP: false;
         MyMissP : '25');

{ --------TTestWindow methods------------------ }
constructor TTestWindow.Init(AParent: PWindowsObject; ATitle: PChar);
var
n:integer;
begin
  inherited Init(AParent, ATitle);
  with Attr do
  begin
  x:=25; y:= 15; w:= 900; h:= 720;
  end;
  Attr.Menu := LoadMenu(HInstance, MakeIntResource(102));
   Attr.style := Attr.Style or ws_VScroll or ws_HScroll;
   Scroller := New(PScroller, Init(@Self, 10, 10, 100, 100));
   waitcursor := loadcursor(0, idc_wait);
  calculated := false;
  makehelix;

  b:=4; Gx:= 20; Gy:=30; scale := 500; U:=1;

  for n:=0 to NubPoints do
  begin
  myX[n] := RANDOM;
  myY[n] := RANDOM;
  X[n] := myX[n];
  Y[n] := myY[n];
  end;
   Mis := 0;
   TotIt := 50;
   MF := 1;
   MisPoint :=27;

   SecondTest := false;
end;

 procedure TTestWindow.StartTest(var Msg: TMessage);
 var n: integer;
 begin
  MakeHelix;
  for n:=0 to NubPoints do
  begin
  X[n] := myX[n];
  Y[n] := myY[n];
  end;
  if Mis > 0 then
  begin
  CreateMisPoint(mispoint);
  messagebeep(0);
  end;

  InvalidateRect(Hwindow, nil, true);
  Updatewindow(hwindow);

  waitcursor := LoadCursor(0, idc_wait);
  setcursor(waitcursor);
 { if Mis >0 then CreateMisPoint(mispoint);}
  OldMatrixCalcul;
  StepestDescent(0,NubPoints);
  FinalErrorCalcul;
  BringCenter(NubPoints div 2);
  destroycursor(waitcursor);
  InvalidateRect(Hwindow, nil, true);
  Updatewindow(hwindow);
 end;

 procedure TTestWindow.CreateMisPoint(apoint:integer);
 var
 MyXh,MyYh,MyZh:extended;
 MyX,MyY: extended;
 n:integer;
 begin
   XHel[nubpoints+1]:= XHel[mispoint];
   YHel[nubpoints+1]:= YHel[mispoint];
   ZHel[nubpoints+1]:= ZHel[mispoint];
  makehelix;
   for N:= mispoint to nubpoints do
   begin
    XHel[n]:=XHel[n+1];
    YHel[n]:=YHel[n+1];
    ZHel[n]:=ZHel[n+1];
    end;
 end;

procedure TTestWindow.MakeHelix;
var
n: integer;
begin
for n:=0 to NubPoints do
begin
ZHel[n] :=n * Sqrt(2)/2;
XHel[n] :=cos(Zhel[n]);
YHel[n] :=sin(Zhel[n]);
end;
end;


  procedure TTestWindow.ProjectMisPoint(var Msg: TMessage);
 var
 R,n,m:integer;
 OldMis : integer;
 begin
 if Mis >0 then
  BEGIN
   if NubConstPoints>= NubPoints then
   begin
   R:=  messagebox(Hwindow,'Nub. Const. Points >= Nub. Points','Error',0);
   exit;
   end;
 OldMis := mis;
 mis:=0;
 waitcursor := LoadCursor(0, idc_wait);
 setcursor(waitcursor);

  X[NubPoints] := Random;
  Y[NubPoints] := Random;

  OldMatrixCalcul;
  StepestDescent(NubPoints,NubPoints);
  FinalErrorCalcul;

  destroycursor(waitcursor);
  {InvalidateRect(Hwindow, nil, true);
  Updatewindow(hwindow);}
  SecondTest := true;
  display;
  Mis := OldMis;
  END
 end;



 procedure TTestWindow.BringCenter(ATPoint:integer);
   var
   k:integer;
   Zx,Zy: extended;
 begin
   if AtPoint > 0 then
   begin
   Zx := X[AtPoint-1]-0.5;
   Zy := Y[AtPoint-1]-0.5;
    for k:=0 to NubPoints-1 do
    begin
    X[k]:= X[k]-Zx;
    Y[k]:= Y[k]-Zy;
    end;
   end;
 end;



 procedure TTestWindow.OldMatrixCalcul;
   var
   k,l,n,m: integer;
   p,q: integer;
   MaxDist: extended;
   Nbr: integer;

    function OldDistCalcul(v,w:integer):extended;
    begin
    OldDistCalcul:= Sqrt(Sqr(Xhel[v]-Xhel[w])+ Sqr(Yhel[v]-Yhel[w]) + Sqr(Zhel[v]-Zhel[w]));
    end;

   BEGIN
      TotalOldDist := 0;
      MaxDist := 0;
      for k:=0  to NubPoints-mis do
       begin
        for l:= 0 to NubPoints-mis do OldDist[K,L] :=0;
       end;

      for k:=0  to NubPoints-mis do
       begin
       for l:= 0 to NubPoints-mis do
        begin
         OldDist[k,l] := OldDistCalcul(k,l);
         if OldDist[k,l] > MaxDist then MaxDist := OldDist[k,l];
       end;
      end;


       for k:=0  to NubPoints-mis do
       begin
       for l:= 0 to NubPoints-mis do  OldDist[K,L] :=OldDist[K,L]/MaxDist;
       end;

      for k :=0 to NubPoints -mis do
      begin
      for  l:=0 to k-1 do  TotalOldDist := TotalOldDist + OldDist[K,L];
      end;

      End;


   procedure TTestWindow.MyOldMatrixCalcul(VarPoint:integer);
   var
   k,l,n,m: integer;
   p,q: integer;
   MaxDist: extended;
   Nbr: integer;

    function OldDistCalcul(v,w:integer):extended;
    begin
    OldDistCalcul:= Sqrt(Sqr(Xhel[v]-Xhel[w])+ Sqr(Yhel[v]-Yhel[w]) + Sqr(Zhel[v]-Zhel[w]));
    end;


   BEGIN
      TotalOldDist := 0;
      MaxDist := 0;
      for k:=0  to NubConstPoints do
       begin
        for l:= 0 to NubConstPoints do OldDist[K,L] :=0;
       end;

      XHel[NubConstPoints]:=XHel[VarPoint];
      YHel[NubConstPoints]:=YHel[VarPoint];
      ZHel[NubConstPoints]:=ZHel[VarPoint];

      for k:=0  to NubConstPoints do
       begin
       for l:= 0 to NubConstPoints do
        begin
         OldDist[k,l] := OldDistCalcul(k,l);
         if OldDist[k,l] > MaxDist then MaxDist := OldDist[k,l];
       end;
      end;


       for k:=0  to NubConstPoints do
       begin
       for l:= 0 to NubConstPoints do  OldDist[K,L] :=OldDist[K,L]/MaxDist;
       end;

      for k :=0 to NubConstPoints do
      begin
      for  l:=0 to k-1 do  TotalOldDist := TotalOldDist + OldDist[K,L];
      end;

      End;

   function TTestWindow.NewDist(v,w: integer): extended;
   begin
     NewDist:= Sqrt(Sqr(X[v]-X[w])+ Sqr(Y[v]-Y[w]));
   end;

  procedure TTestWindow.StepestDescent(NubConstPoints,MaxPoints: integer);
  var
  n,m: integer;
  Msg: Tmessage;
   nub1,nub2: array [0..NubPoints] of char;

   function FirstDerivX(p: integer): extended;
   var
   S1X: extended;
   K: integer;
    begin
       s1X:=0; ;
     for K := 0 to NubPoints-Mis do
     begin
     if p <> K then
     s1x := s1x + (OldDist[p,k] - newdist(p,k))*(x[p] -x[k])/(NewDist(p,k)*Olddist[p,k]);
     end;
      FirstDerivX := -2* S1X/TotalOldDist;
    end;

   function FirstDerivY(p: integer): extended;
   var
    S1Y: extended;
    K: integer;
    begin
       S1Y := 0;
     for K:= 0 to NubPoints-Mis do
     begin
     if p <> k then
     s1y := s1y + (OldDist[p,k] - newdist(p,k))*(y[p]- y[k])/(NewDist(p,k)*Olddist[p,k]);
     end;
      FirstDerivY := -2* S1Y/TotalOldDist;
    end;


   function  SecondDerivX(p:integer): extended;
    var
    S2X : extended;
    K,L: integer;
    begin
      S2X:=0;
     for K:= 0 to NubPoints-mis do
     begin
      if (p <> k) then
     s2x := s2x +   (1/(OldDist[p,k]*NewDist(p,k))) *
    ((oldDist[p,k]-newDist(p,k))-sqr(x[p]-x[k])*(1+(oldDist[p,k]-newDist(p,k))/newdist(p,k))
                                                                              /newdist(p,k));
     end;
      SecondDerivX := -2* S2X/TotalOldDist;
    end;

 function  SecondDerivY(p:integer): extended;
    var
    S2Y : extended;
    K,L: integer;
    begin
      S2Y:=0;
     for K:= 0 to NubPoints-mis do
     begin
      if (p <> k) then
     S2Y := S2Y +   (1/(OldDist[p,k]*NewDist(p,k))) *
    ((oldDist[p,k]-newDist(p,k))-sqr(y[p]-y[k])*(1+(oldDist[p,k]-newDist(p,k))/newdist(p,k))
                                                                              /newdist(p,k));
     end;
      SecondDerivY := -2* S2Y/TotalOldDist;
    end;


  Begin
  for m:=0 to  TotIt do
      begin

    for n:=NubConstPoints to MaxPoints-Mis do
      begin
        Y[n] := Y[n] - MF * FirstDerivY(n)/abs(secondDerivY(n));
        X[n] := X[n] - MF * FirstDerivX(n)/abs(secondDerivX(n));
      end;

   end;
  End;

  {--------------------------------------------------------------------------------------------}


  {--------------------------------------------------------------------------------------------}


   procedure TTestWindow.FinalErrorCalcul;
     var
     S: extended;
     i,j: integer;
   begin
      S :=0;
      for i :=0 to NubPoints-mis do
      begin
      for  j:=0 to i-1 do
      begin
       S:=  S + sqr(olddist[i,j] - newdist(i,j)) / olddist[i,j];
      end;
      end;
     Error := S/TotalOldDist;
   end;

 procedure TTestWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
 var
 nub: array [0..99] of char;
 k,l,m,n, NPoints:integer;
 NewPen,OldPen: HPen;
  begin
  TWindow.Paint(PaintDc, PaintInfo);
  If secondtest then NPoints := NubConstPoints else NPoints:= NubPoints;

          str(Error:1:6, nub);
          strcat (nub, ' - Final Error');
          textout(paintdc, 10,0, nub, strlen(nub));

         Rectangle(PaintDC, Gx, Gy, Gx+U*scale, Gy+U*scale);

         NewPen := CreatePen(ps_solid, b ,paletteindex(13) );
         OldPen := selectObject(paintdc, newpen);
         for n:=0 to NubPoints-mis do
         begin
         {B:=2;}
           Rectangle(paintDc, Gx+ round(scale*x[n])-b, Gy+round(scale*y[n])-b,
                            Gx+ round(scale*x[n])+b, Gy+round(scale*y[n])+b);
          str(n, nub);
          textout(paintDc, Gx+ round(scale*x[n]), Gy+round(scale*y[n]), nub, strlen(nub));
         end;
         SelectObject(paintDc, OldPen);
         Deleteobject(newpen);

          if Mis > 0 then
          begin
         { B:=3; }  N:=NubPoints;
          Rectangle(paintDc, Gx+ round(scale*x[n])-b, Gy+round(scale*y[n])-b,
                            Gx+ round(scale*x[n])+b, Gy+round(scale*y[n])+b);
                            OldX := x[n]; OldY := Y[n];
          end;

  end;

 procedure TTestwindow.Display;
var
thedc: HDC;
k,l,m,n,Color,b: integer;
 nub: array [0..99] of char;
NewPen, OldPen: HPen;
begin
 TheDc := getdc(hwindow);
 {erase old missing point}
 Color:=19; {B:=3; }  N:=NubPoints;
 NewPen := CreatePen(ps_solid, b ,paletteindex(color) );
 OldPen := selectObject(thedc, newpen);

          Rectangle(theDc, Gx+ round(scale*OldX)-b, Gy+round(scale*OldY)-b,
                            Gx+ round(scale*OldX+b), Gy+round(scale*OldY)+b);
  SelectObject(theDc, OldPen);
  Deleteobject(newpen);

  {paint projected missing point}
          Color:=1;  {b:=1;}

          messagebeep(0);
          str(Error:1:6, nub);
          strcat (nub, ' - Final Error');
          textout(thedc, 10,0, nub, strlen(nub));
         NewPen := CreatePen(ps_solid, b ,paletteindex(color) );
         OldPen := selectObject(thedc, newpen);

        { B:=3; }  N:=NubPoints;
         Rectangle(theDc, Gx+ round(scale*x[n])-b, Gy+round(scale*y[n])-b,
                          Gx+ round(scale*x[n])+b, Gy+round(scale*y[n])+b);

         SelectObject(theDc, OldPen);
         Deleteobject(newpen);


 releaseDC(HWindow ,thedc);
end;

 procedure TTestWindow.CMSettings(var Msg: TMessage);
   var
   RV, code1, code2, code3: integer;
   E1,E2,E3,E4: PEdit;
   PB: PRadioButton;
   MySettings: PDialog;
   PrevMF: real;
   begin
    prevMF := MF;
   str(TotIt, SettRecord.MyTotIt);
   str(MF:2:2, SettRecord.MyMF);
   str(MisPoint, SettRecord.MyMissP);
   if mis = 0  then SettRecord.MyOutP := false else SettRecord.MyOutP := true;
   {transferData(tf_setData);}


        MySettings:= New(PDialog, Init(@self,MakeIntResource('Dialog_2')));
         new(E1,Initresource(MySettings, 304, sizeof(SettRecord.MyTotIt)));
           {  E1^.setvalidator(New(PRangeValidator, Init(0,999) ));}
         new(E2,Initresource(MySettings, 305, sizeof(SettRecord.MyMf)));
          {E2^.setvalidator(New(PRangeValidator, Init(0,1) ));}
        new(PB,Initresource(MySettings, 307));
        new(E3,Initresource(MySettings, 306, sizeof(SettRecord.MyMissP)));
           {  E3^.setvalidator(New(PRangeValidator, Init(0,Constnbr) )); }


       MySettings^.transferbuffer:= @SettRecord;
       RV:= Application^.ExecDialog(MySettings);

       if RV = 1 then
       begin
   val(SettRecord.MyTotIt, TotIt, code1);
   val(SettRecord.MyMF, MF, code2);
    if code2 <> 0 then MF := prevMF;
    val(SettRecord.MyMissP, MisPoint, code2);
   if   SettRecord.MyOutP = true then Mis := 1 else Mis := 0;
        end;
   end;





{ -----------TTestApplication Methods------------ }
procedure TTestApplication.InitMainWindow;
begin
  MainWindow := New(PTestWindow, Init(nil, 'Sammon Projection of Helix'));
  HAccTable := LoadAccelerators(HInstance, MakeIntResource(100));
end;

var
  TestApp : TTestApplication;
 
begin
  TestApp.Init('EWndTest');
  TestApp.Run;
  TestApp.Done;
end.



